Index: /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/variable.f90
===================================================================
--- /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/variable.f90	(revision 5074)
+++ /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/variable.f90	(revision 5075)
@@ -3414,53 +3781,56 @@
       
    END FUNCTION var__init_3D_i2
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This function initalise a variable structure.
-   !> - integer(2) 4D table of value could be added. 
-   !> - dimension structure could be added.
-   !> - attribute structure could be added
-   !
+   !-------------------------------------------------------------------
+   !> @brief This function initialize a variable structure,
+   !> with a integer(2) 4D array of value.
    !> @details 
+   !> optionally could be added:<br/>
+   !> - dimension structure.
+   !> - attribute structure.
+   !>
    !> Dimension structure is needed to put value in variable structure. 
-   !> If none is given, we assume table is ordered as ('x','y','z','t') and we 
-   !> use table size as lentgh dimension. 
+   !> If none is given, we assume array is ordered as ('x','y','z','t') and we 
+   !> use array size as lentgh dimension. 
    !>
    !> indices in the variable where value will be written could be specify if
-   !> start and count table are given. Dimension structure is needed in that 
+   !> start and count array are given. Dimension structure is needed in that 
    !> case.    
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] cd_name : variable name
-   !> @param[in] sd_value : 4D table of integer(2) value
-   !> @param[in] id_start : index in the variable from which the data values 
-   !> will be read
-   !> @param[in] id_count : number of indices selected along each dimension
-   !> @param[in] id_type : variable type 
-   !> @param[in] td_dim   : table of dimension structure
-   !> @param[in] td_att  : table of attribute structure
-   !> @param[in] sd_fill : fill value
-   !> @param[in] cd_units : units
-   !> @param[in] cd_stdname : variable standard name
-   !> @param[in] cd_longname : variable long name
-   !> @param[in] cd_point : point on Arakawa-C grid (T,U,V,F)
-   !> @param[in] id_id : variable id
-   !> @param[in] id_ew : east west wrap
-   !> @param[in] dd_scf  : scale factor
-   !> @param[in] dd_ofs  : add offset
-   !> @param[in] id_rec : record id (for rstdimg file)
-   !> @param[in] dd_min : minimum value
-   !> @param[in] dd_max : maximum value
-   !> @param[in] ld_contiguous : use contiguous storage or not 
-   !> @param[in] ld_shuffle :  shuffle filter is turned on or not
-   !> @param[in] ld_fletcher32 : fletcher32 filter is turned on or not
-   !> @param[in] id_deflvl : deflate level from 0 to 9, 0 indicates no deflation is in use
-   !> @param[in] id_chunksz : chunk size
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] cd_name         variable name
+   !> @param[in] sd_value        4D array of integer(2) value
+   !> @param[in] id_start        index in the variable from which the 
+   !> data values will be read
+   !> @param[in] id_count        number of indices selected along 
+   !> each dimension
+   !> @param[in] id_type         variable type 
+   !> @param[in] td_dim          array of dimension structure
+   !> @param[in] td_att          array of attribute structure
+   !> @param[in] sd_fill         fill value
+   !> @param[in] cd_units        units
+   !> @param[in] cd_axis         axis expected to be used
+   !> @param[in] cd_stdname      variable standard name
+   !> @param[in] cd_longname     variable long name
+   !> @param[in] cd_point        point on Arakawa-C grid (T,U,V,F)
+   !> @param[in] id_id           variable id
+   !> @param[in] id_ew           east west wrap
+   !> @param[in] dd_scf          scale factor
+   !> @param[in] dd_ofs          add offset
+   !> @param[in] id_rec          record id (for rstdimg file)
+   !> @param[in] dd_min          minimum value
+   !> @param[in] dd_max          maximum value
+   !> @param[in] ld_contiguous   use contiguous storage or not 
+   !> @param[in] ld_shuffle       shuffle filter is turned on or not
+   !> @param[in] ld_fletcher32   fletcher32 filter is turned on or not
+   !> @param[in] id_deflvl       deflate level from 0 to 9, 0 indicates no 
+   !> deflation is in use
+   !> @param[in] id_chunksz      chunk size
+   !> @return variable structure
+   !-------------------------------------------------------------------
    TYPE(TVAR) FUNCTION var__init_i2( cd_name, sd_value,        &
    &                                 id_start, id_count, id_type, td_dim, &
-   &                                 td_att, sd_fill, cd_units,&
+   &                                 td_att, sd_fill, cd_units, cd_axis,&
    &                                 cd_stdname, cd_longname,  &
    &                                 cd_point, id_id, id_ew,   &
@@ -3481,4 +3851,5 @@
       INTEGER(i2)     ,                       INTENT(IN), OPTIONAL :: sd_fill
       CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_units
+      CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_axis 
       CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_stdname
       CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_longname
@@ -3532,4 +3903,5 @@
       &                      dd_fill=dl_fill,                    &
       &                      cd_units=cd_units,                  &
+      &                      cd_axis=cd_axis,                    &
       &                      cd_stdname=cd_stdname,              &
       &                      cd_longname=cd_longname,            &
@@ -3546,65 +3918,57 @@
       DEALLOCATE( dl_value )
       
-!      ! add value
-!      IF( .NOT. PRESENT(td_dim) )THEN
-!         il_shape(:)=SHAPE(sd_value(:,:,:,:)) 
-!         DO ji=1,ip_maxdim
-!            tl_dim=dim_init( cp_dimorder(ji:ji), id_len=il_shape(ji)) 
-!            CALL var_add_dim(var__init_i2, tl_dim)
-!         ENDDO
-!      ENDIF
-!      CALL var_add_value(var__init_i2, sd_value(:,:,:,:), &
-!      &                  id_start(:), id_count(:))
-      
    END FUNCTION var__init_i2
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This function initalise a variable structure.
-   !> - integer(1) 1D table of value could be added. 
-   !> - dimension structure could be added.
-   !> - attribute structure could be added
-   !
+   !-------------------------------------------------------------------
+   !> @brief This function initialize a variable structure,
+   !> with a integer(1) 1D array of value.
    !> @details 
+   !> optionally could be added:<br/>
+   !> - dimension structure.
+   !> - attribute structure.
+   !>
    !> dimension structure is needed to put value in variable structure. 
-   !> If none is given, we assume table is ordered as ('z') and we 
-   !> use table size as lentgh dimension. 
+   !> If none is given, we assume array is ordered as ('z') and we 
+   !> use array size as lentgh dimension. 
    !>
    !> indices in the variable where value will be written could be specify if
-   !> start and count table are given. Dimension structure is needed in that 
+   !> start and count array are given. Dimension structure is needed in that 
    !> case.    
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] cd_name : variable name
-   !> @param[in] bd_value : 1D table of integer(1) value
-   !> @param[in] id_start : index in the variable from which the data values 
-   !> will be read
-   !> @param[in] id_count : number of indices selected along each dimension
-   !> @param[in] id_type : variable type 
-   !> @param[in] td_dim   : table of dimension structure
-   !> @param[in] td_att  : table of attribute structure
-   !> @param[in] bd_fill : fill value
-   !> @param[in] cd_units : units
-   !> @param[in] cd_stdname : variable standard name
-   !> @param[in] cd_longname : variable long name
-   !> @param[in] cd_point : point on Arakawa-C grid (T,U,V,F)
-   !> @param[in] id_id : variable id
-   !> @param[in] id_ew : east west wrap
-   !> @param[in] dd_scf  : scale factor
-   !> @param[in] dd_ofs  : add offset
-   !> @param[in] id_rec : record id (for rstdimg file)
-   !> @param[in] dd_min : minimum value
-   !> @param[in] dd_max : maximum value
-   !> @param[in] ld_contiguous : use contiguous storage or not 
-   !> @param[in] ld_shuffle :  shuffle filter is turned on or not
-   !> @param[in] ld_fletcher32 : fletcher32 filter is turned on or not
-   !> @param[in] id_deflvl : deflate level from 0 to 9, 0 indicates no deflation is in use
-   !> @param[in] id_chunksz : chunk size
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] cd_name         variable name
+   !> @param[in] bd_value        1D array of integer(1) value
+   !> @param[in] id_start        index in the variable from which the 
+   !> data values will be read
+   !> @param[in] id_count        number of indices selected along 
+   !> each dimension
+   !> @param[in] id_type         variable type 
+   !> @param[in] td_dim          array of dimension structure
+   !> @param[in] td_att          array of attribute structure
+   !> @param[in] bd_fill         fill value
+   !> @param[in] cd_units        units
+   !> @param[in] cd_axis         axis expected to be used
+   !> @param[in] cd_stdname      variable standard name
+   !> @param[in] cd_longname     variable long name
+   !> @param[in] cd_point        point on Arakawa-C grid (T,U,V,F)
+   !> @param[in] id_id           variable id
+   !> @param[in] id_ew           east west wrap
+   !> @param[in] dd_scf          scale factor
+   !> @param[in] dd_ofs          add offset
+   !> @param[in] id_rec          record id (for rstdimg file)
+   !> @param[in] dd_min          minimum value
+   !> @param[in] dd_max          maximum value
+   !> @param[in] ld_contiguous   use contiguous storage or not 
+   !> @param[in] ld_shuffle       shuffle filter is turned on or not
+   !> @param[in] ld_fletcher32   fletcher32 filter is turned on or not
+   !> @param[in] id_deflvl       deflate level from 0 to 9, 0 indicates no 
+   !> deflation is in use
+   !> @param[in] id_chunksz      chunk size
+   !> @return variable structure
+   !-------------------------------------------------------------------
    TYPE(TVAR) FUNCTION var__init_1D_i1( cd_name, bd_value,        &
    &                                    id_start, id_count, id_type, td_dim, &
-   &                                    td_att, bd_fill, cd_units,&
+   &                                    td_att, bd_fill, cd_units, cd_axis,&
    &                                    cd_stdname, cd_longname,  &
    &                                    cd_point, id_id, id_ew,   &
@@ -3625,4 +3989,5 @@
       INTEGER(i1)     ,                       INTENT(IN), OPTIONAL :: bd_fill
       CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_units
+      CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_axis 
       CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_stdname
       CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_longname
@@ -3672,4 +4037,5 @@
       &                         dd_fill=dl_fill,                    &
       &                         cd_units=cd_units,                  &
+      &                         cd_axis=cd_axis,                    &
       &                         cd_stdname=cd_stdname,              &
       &                         cd_longname=cd_longname,            &
@@ -3687,53 +4053,56 @@
  
    END FUNCTION var__init_1D_i1
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This function initalise a variable structure.
-   !> - integer(1) 2D table of value could be added. 
-   !> - dimension structure could be added.
-   !> - attribute structure could be added
-   !
+   !-------------------------------------------------------------------
+   !> @brief This function initialize a variable structure,
+   !> with a integer(1) 2D array of value.
    !> @details 
-   !> table of 2 dimension structure is needed to put value in variable structure. 
-   !> If none is given, we assume table is ordered as ('x','y') and we 
-   !> use table size as lentgh dimension. 
+   !> optionally could be added:<br/>
+   !> - dimension structure.
+   !> - attribute structure.
+   !>
+   !> array of 2 dimension structure is needed to put value in variable structure. 
+   !> If none is given, we assume array is ordered as ('x','y') and we 
+   !> use array size as lentgh dimension. 
    !>
    !> indices in the variable where value will be written could be specify if
-   !> start and count table are given. Dimension structure is needed in that 
+   !> start and count array are given. Dimension structure is needed in that 
    !> case.    
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] cd_name : variable name
-   !> @param[in] bd_value : 2D table of integer(1) value
-   !> @param[in] id_start : index in the variable from which the data values 
-   !> will be read
-   !> @param[in] id_count : number of indices selected along each dimension
-   !> @param[in] id_type : variable type 
-   !> @param[in] td_dim   : table of dimension structure
-   !> @param[in] td_att  : table of attribute structure
-   !> @param[in] bd_fill : fill value
-   !> @param[in] cd_units : units
-   !> @param[in] cd_stdname : variable standard name
-   !> @param[in] cd_longname : variable long name
-   !> @param[in] cd_point : point on Arakawa-C grid (T,U,V,F)
-   !> @param[in] id_id : variable id
-   !> @param[in] id_ew : east west wrap
-   !> @param[in] dd_scf  : scale factor
-   !> @param[in] dd_ofs  : add offset
-   !> @param[in] id_rec : record id (for rstdimg file)
-   !> @param[in] dd_min : minimum value
-   !> @param[in] dd_max : maximum value
-   !> @param[in] ld_contiguous : use contiguous storage or not 
-   !> @param[in] ld_shuffle :  shuffle filter is turned on or not
-   !> @param[in] ld_fletcher32 : fletcher32 filter is turned on or not
-   !> @param[in] id_deflvl : deflate level from 0 to 9, 0 indicates no deflation is in use
-   !> @param[in] id_chunksz : chunk size
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] cd_name         variable name
+   !> @param[in] bd_value        2D array of integer(1) value
+   !> @param[in] id_start        index in the variable from which the 
+   !> data values will be read
+   !> @param[in] id_count        number of indices selected along 
+   !> each dimension
+   !> @param[in] id_type         variable type 
+   !> @param[in] td_dim          array of dimension structure
+   !> @param[in] td_att          array of attribute structure
+   !> @param[in] bd_fill         fill value
+   !> @param[in] cd_units        units
+   !> @param[in] cd_axis         axis expected to be used
+   !> @param[in] cd_stdname      variable standard name
+   !> @param[in] cd_longname     variable long name
+   !> @param[in] cd_point        point on Arakawa-C grid (T,U,V,F)
+   !> @param[in] id_id           variable id
+   !> @param[in] id_ew           east west wrap
+   !> @param[in] dd_scf          scale factor
+   !> @param[in] dd_ofs          add offset
+   !> @param[in] id_rec          record id (for rstdimg file)
+   !> @param[in] dd_min          minimum value
+   !> @param[in] dd_max          maximum value
+   !> @param[in] ld_contiguous   use contiguous storage or not 
+   !> @param[in] ld_shuffle       shuffle filter is turned on or not
+   !> @param[in] ld_fletcher32   fletcher32 filter is turned on or not
+   !> @param[in] id_deflvl       deflate level from 0 to 9, 0 indicates no 
+   !> deflation is in use
+   !> @param[in] id_chunksz      chunk size
+   !> @return variable structure
+   !-------------------------------------------------------------------
    TYPE(TVAR) FUNCTION var__init_2D_i1( cd_name, bd_value,        &
    &                                    id_start, id_count, id_type, td_dim, &
-   &                                    td_att, bd_fill, cd_units,&
+   &                                    td_att, bd_fill, cd_units, cd_axis,&
    &                                    cd_stdname, cd_longname,  &
    &                                    cd_point, id_id, id_ew,   &
@@ -3747,6 +4116,6 @@
       CHARACTER(LEN=*),                       INTENT(IN) :: cd_name
       INTEGER(i1)     , DIMENSION(:,:)     ,  INTENT(IN) :: bd_value
-      INTEGER(i4)     , DIMENSION(:)       , INTENT(IN), OPTIONAL :: id_start
-      INTEGER(i4)     , DIMENSION(:)       , INTENT(IN), OPTIONAL :: id_count
+      INTEGER(i4)     , DIMENSION(:)       ,  INTENT(IN), OPTIONAL :: id_start
+      INTEGER(i4)     , DIMENSION(:)       ,  INTENT(IN), OPTIONAL :: id_count
       INTEGER(i4)     ,                       INTENT(IN), OPTIONAL :: id_type 
       TYPE(TDIM)      , DIMENSION(:)       ,  INTENT(IN), OPTIONAL :: td_dim
@@ -3754,4 +4123,5 @@
       INTEGER(i1)     ,                       INTENT(IN), OPTIONAL :: bd_fill
       CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_units
+      CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_axis 
       CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_stdname
       CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_longname
@@ -3803,4 +4173,5 @@
       &                         dd_fill=dl_fill,                    &
       &                         cd_units=cd_units,                  &
+      &                         cd_axis=cd_axis,                    &
       &                         cd_stdname=cd_stdname,              &
       &                         cd_longname=cd_longname,            &
@@ -3818,53 +4189,56 @@
       
    END FUNCTION var__init_2D_i1
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This function initalise a variable structure.
-   !> - integer(1) 2D table of value could be added. 
-   !> - dimension structure could be added.
-   !> - attribute structure could be added
-   !
+   !-------------------------------------------------------------------
+   !> @brief This function initialize a variable structure,
+   !> with a integer(1) 3D array of value.
    !> @details 
-   !> table of 2 dimension structure is needed to put value in variable structure. 
-   !> If none is given, we assume table is ordered as ('x','y') and we 
-   !> use table size as lentgh dimension. 
+   !> optionally could be added:<br/>
+   !> - dimension structure.
+   !> - attribute structure.
+   !>
+   !> array of 3 dimension structure is needed to put value in variable structure. 
+   !> If none is given, we assume array is ordered as ('x','y','z') and we 
+   !> use array size as lentgh dimension. 
    !>
    !> indices in the variable where value will be written could be specify if
-   !> start and count table are given. Dimension structure is needed in that 
+   !> start and count array are given. Dimension structure is needed in that 
    !> case.    
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] cd_name : variable name
-   !> @param[in] bd_value : 2D table of integer(1) value
-   !> @param[in] id_start : index in the variable from which the data values 
-   !> will be read
-   !> @param[in] id_count : number of indices selected along each dimension
-   !> @param[in] id_type : variable type 
-   !> @param[in] td_dim   : table of dimension structure
-   !> @param[in] td_att  : table of attribute structure
-   !> @param[in] bd_fill : fill value
-   !> @param[in] cd_units : units
-   !> @param[in] cd_stdname : variable standard name
-   !> @param[in] cd_longname : variable long name
-   !> @param[in] cd_point : point on Arakawa-C grid (T,U,V,F)
-   !> @param[in] id_id : variable id
-   !> @param[in] id_ew : east west wrap
-   !> @param[in] dd_scf  : scale factor
-   !> @param[in] dd_ofs  : add offset
-   !> @param[in] id_rec : record id (for rstdimg file)
-   !> @param[in] dd_min : minimum value
-   !> @param[in] dd_max : maximum value
-   !> @param[in] ld_contiguous : use contiguous storage or not 
-   !> @param[in] ld_shuffle :  shuffle filter is turned on or not
-   !> @param[in] ld_fletcher32 : fletcher32 filter is turned on or not
-   !> @param[in] id_deflvl : deflate level from 0 to 9, 0 indicates no deflation is in use
-   !> @param[in] id_chunksz : chunk size
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] cd_name         variable name
+   !> @param[in] bd_value        3D array of integer(1) value
+   !> @param[in] id_start        index in the variable from which the 
+   !> data values will be read
+   !> @param[in] id_count        number of indices selected along 
+   !> each dimension
+   !> @param[in] id_type         variable type 
+   !> @param[in] td_dim          array of dimension structure
+   !> @param[in] td_att          array of attribute structure
+   !> @param[in] bd_fill         fill value
+   !> @param[in] cd_units        units
+   !> @param[in] cd_axis         axis expected to be used
+   !> @param[in] cd_stdname      variable standard name
+   !> @param[in] cd_longname     variable long name
+   !> @param[in] cd_point        point on Arakawa-C grid (T,U,V,F)
+   !> @param[in] id_id           variable id
+   !> @param[in] id_ew           east west wrap
+   !> @param[in] dd_scf          scale factor
+   !> @param[in] dd_ofs          add offset
+   !> @param[in] id_rec          record id (for rstdimg file)
+   !> @param[in] dd_min          minimum value
+   !> @param[in] dd_max          maximum value
+   !> @param[in] ld_contiguous   use contiguous storage or not 
+   !> @param[in] ld_shuffle       shuffle filter is turned on or not
+   !> @param[in] ld_fletcher32   fletcher32 filter is turned on or not
+   !> @param[in] id_deflvl       deflate level from 0 to 9, 0 indicates no 
+   !> deflation is in use
+   !> @param[in] id_chunksz      chunk size
+   !> @return variable structure
+   !-------------------------------------------------------------------
    TYPE(TVAR) FUNCTION var__init_3D_i1( cd_name, bd_value,        &
    &                                    id_start, id_count, id_type, td_dim, &
-   &                                    td_att, bd_fill, cd_units,&
+   &                                    td_att, bd_fill, cd_units, cd_axis,&
    &                                    cd_stdname, cd_longname,  &
    &                                    cd_point, id_id, id_ew,   &
@@ -3878,6 +4252,6 @@
       CHARACTER(LEN=*),                       INTENT(IN) :: cd_name
       INTEGER(i1)     , DIMENSION(:,:,:)   ,  INTENT(IN) :: bd_value
-      INTEGER(i4)     , DIMENSION(:)       , INTENT(IN), OPTIONAL :: id_start
-      INTEGER(i4)     , DIMENSION(:)       , INTENT(IN), OPTIONAL :: id_count
+      INTEGER(i4)     , DIMENSION(:)       ,  INTENT(IN), OPTIONAL :: id_start
+      INTEGER(i4)     , DIMENSION(:)       ,  INTENT(IN), OPTIONAL :: id_count
       INTEGER(i4)     ,                       INTENT(IN), OPTIONAL :: id_type 
       TYPE(TDIM)      , DIMENSION(:)       ,  INTENT(IN), OPTIONAL :: td_dim
@@ -3885,4 +4259,5 @@
       INTEGER(i1)     ,                       INTENT(IN), OPTIONAL :: bd_fill
       CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_units
+      CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_axis 
       CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_stdname
       CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_longname
@@ -3935,4 +4310,5 @@
       &                         dd_fill=dl_fill,                    &
       &                         cd_units=cd_units,                  &
+      &                         cd_axis=cd_axis,                    &
       &                         cd_stdname=cd_stdname,              &
       &                         cd_longname=cd_longname,            &
@@ -3950,53 +4326,56 @@
       
    END FUNCTION var__init_3D_i1
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This function initalise a variable structure.
-   !> - integer(1) 4D table of value could be added. 
-   !> - dimension structure could be added.
-   !> - attribute structure could be added
-   !
+   !-------------------------------------------------------------------
+   !> @brief This function initialize a variable structure,
+   !> with a integer(1) 4D array of value.
    !> @details 
+   !> optionally could be added:<br/>
+   !> - dimension structure.
+   !> - attribute structure.
+   !>
    !> Dimension structure is needed to put value in variable structure. 
-   !> If none is given, we assume table is ordered as ('x','y','z','t') and we 
-   !> use table size as lentgh dimension. 
+   !> If none is given, we assume array is ordered as ('x','y','z','t') and we 
+   !> use array size as lentgh dimension. 
    !>
    !> indices in the variable where value will be written could be specify if
-   !> start and count table are given. Dimension structure is needed in that 
-   !> case.    
+   !> start and count array are given. Dimension structure is needed in that 
+   !> case. 
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] cd_name : variable name
-   !> @param[in] bd_value : 4D table of integer(1) value
-   !> @param[in] id_start : index in the variable from which the data values 
-   !> will be read
-   !> @param[in] id_count : number of indices selected along each dimension
-   !> @param[in] id_type : variable type 
-   !> @param[in] td_dim   : table of dimension structure
-   !> @param[in] td_att  : table of attribute structure
-   !> @param[in] bd_fill : fill value
-   !> @param[in] cd_units : units
-   !> @param[in] cd_stdname : variable standard name
-   !> @param[in] cd_longname : variable long name
-   !> @param[in] cd_point : point on Arakawa-C grid (T,U,V,F)
-   !> @param[in] id_id : variable id
-   !> @param[in] id_ew : east west wrap
-   !> @param[in] dd_scf  : scale factor
-   !> @param[in] dd_ofs  : add offset
-   !> @param[in] id_rec : record id (for rstdimg file)
-   !> @param[in] dd_min : minimum value
-   !> @param[in] dd_max : maximum value
-   !> @param[in] ld_contiguous : use contiguous storage or not 
-   !> @param[in] ld_shuffle :  shuffle filter is turned on or not
-   !> @param[in] ld_fletcher32 : fletcher32 filter is turned on or not
-   !> @param[in] id_deflvl : deflate level from 0 to 9, 0 indicates no deflation is in use
-   !> @param[in] id_chunksz : chunk size
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] cd_name         variable name
+   !> @param[in] bd_value        4D array of integer(1) value
+   !> @param[in] id_start        index in the variable from which the 
+   !> data values will be read
+   !> @param[in] id_count        number of indices selected along 
+   !> each dimension
+   !> @param[in] id_type         variable type 
+   !> @param[in] td_dim          array of dimension structure
+   !> @param[in] td_att          array of attribute structure
+   !> @param[in] bd_fill         fill value
+   !> @param[in] cd_units        units
+   !> @param[in] cd_axis         axis expected to be used
+   !> @param[in] cd_stdname      variable standard name
+   !> @param[in] cd_longname     variable long name
+   !> @param[in] cd_point        point on Arakawa-C grid (T,U,V,F)
+   !> @param[in] id_id           variable id
+   !> @param[in] id_ew           east west wrap
+   !> @param[in] dd_scf          scale factor
+   !> @param[in] dd_ofs          add offset
+   !> @param[in] id_rec          record id (for rstdimg file)
+   !> @param[in] dd_min          minimum value
+   !> @param[in] dd_max          maximum value
+   !> @param[in] ld_contiguous   use contiguous storage or not 
+   !> @param[in] ld_shuffle       shuffle filter is turned on or not
+   !> @param[in] ld_fletcher32   fletcher32 filter is turned on or not
+   !> @param[in] id_deflvl       deflate level from 0 to 9, 0 indicates no 
+   !> deflation is in use
+   !> @param[in] id_chunksz      chunk size
+   !> @return variable structure
+   !-------------------------------------------------------------------
    TYPE(TVAR) FUNCTION var__init_i1( cd_name, bd_value,        &
    &                                 id_start, id_count, id_type, td_dim, &
-   &                                 td_att, bd_fill, cd_units,&
+   &                                 td_att, bd_fill, cd_units, cd_axis,&
    &                                 cd_stdname, cd_longname,  &
    &                                 cd_point, id_id, id_ew,   &
@@ -4017,4 +4396,5 @@
       INTEGER(i1)     ,                       INTENT(IN), OPTIONAL :: bd_fill
       CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_units
+      CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_axis 
       CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_stdname
       CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_longname
@@ -4068,4 +4448,5 @@
       &                      dd_fill=dl_fill,                    &
       &                      cd_units=cd_units,                  &
+      &                      cd_axis=cd_axis,                    &
       &                      cd_stdname=cd_stdname,              &
       &                      cd_longname=cd_longname,            &
@@ -4082,17 +4463,5 @@
       DEALLOCATE( dl_value )
       
-!      ! add value
-!      IF( .NOT. PRESENT(td_dim) )THEN
-!         il_shape(:)=SHAPE(bd_value(:,:,:,:)) 
-!         DO ji=1,ip_maxdim
-!            tl_dim=dim_init( cp_dimorder(ji:ji), id_len=il_shape(ji)) 
-!            CALL var_add_dim(var__init_i1, tl_dim)
-!         ENDDO
-!      ENDIF
-!      CALL var_add_value(var__init_i1, bd_value(:,:,:,:), &
-!      &                  id_start(:), id_count(:))
-      
    END FUNCTION var__init_i1
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief  This function concatenate variable value following DIM direction.
@@ -4101,14 +4470,14 @@
    !> By default variable are concatenate following time dimension. To
    !> concatenate following another dimension, specify DIM=x where x is the
-   !> dimension number (1,2,3,4) 
+   !> dimension number (jp_I, jp_J,jp_K, jp_L). 
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_var1 : variable structure
-   !> @param[in] td_var2 : variable structure
-   !> @param[in] DIM : dimension following which concatenate  
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] td_var1   variable structure
+   !> @param[in] td_var2   variable structure
+   !> @param[in] DIM       dimension following which concatenate
+   !> @return variable structure
+   !-------------------------------------------------------------------
    FUNCTION var_concat(td_var1, td_var2, DIM)
       IMPLICIT NONE
